#!/usr/local/bin/lua
require("print_r")		-- make nice dumps of tables

require "xavante"
require "xavante.filehandler"
require "xavante.cgiluahandler"
require "xavante.redirecthandler"

local fs=require "lfs"

-- This stuff needed to run Xavante without installing Kepler
CGILUA_CONF='xyzzy'
CGILUA_ISDIRECT=true
RINGS_CGILUA_GLOBALS = {
    'cgilua', "KEPLER_APPS", "KEPLER_CONF", "KEPLER_LIB", 
    "KEPLER_LOG", "KEPLER_LUA", "KEPLER_TMP", "KEPLER_WEB",
    "CGILUA_APPS", "CGILUA_CONF", "CGILUA_TMP", "CGILUA_ISDIRECT",
}

-- Define here where Xavante HTTP documents scripts are located
package.path = lfs.currentdir()..'/?.lua;'.. package.path
local webDir = lfs.currentdir() .. '/htdocs'
local simplerules = {
{ match = "(.+)%.cgi$", with = xavante.redirecthandler, params = { "%1.lua" } },

    { -- URI remapping example
      match = "^[^%./]*/$",
      with = xavante.redirecthandler,
      params = {"index.lp"}
    }, 
    { -- URI remapping example
      match = "%.inc$",
      with = xavante.redirecthandler,
      params = {"/404.lua"}
    }, 
    { -- cgiluahandler example
      match = {"%.lp$", "%.lua$" },
      with = xavante.cgiluahandler.makeHandler (webDir)
    },
    { -- filehandler example
      match = ".",
      with = xavante.filehandler,
      params = {baseDir = webDir}
    },
} 

xavante.HTTP{
    server = {host = "*", port = 8080},
    
    defaultHost = {
    	rules = simplerules
    },
}

xavante.start()
