-- execute a command and return output as string
function get_command_output(cmd)
  local info,p
  p=io.popen(cmd)
  info = p and p:read('*all') or "error in '" .. cmd .. "'"
  p:close()
  return info
end

-- Build a table with everything we need for a page
function get_page_info()
   local P = {}
   P.cgi = package.loaded.cgilua
   P._menu, err = loadfile('menu.inc')
   P._menu = P._menu and P._menu() or {}
   -- /foo/bar/stuff.lua  => dir=/foo/bar, file=stuff.lua, page=stuff
   P.path = P.cgi.urlpath
   P.dir, P.file = P.cgi.splitpath(P.path)
   P.page =  string.match(P.file, '(.*)%.')
   for _,v in ipairs(P._menu) do
     if v.link==P.file then P.title=v.title end
   end
   P.title = P.title or P.path
   P.query = P.cgi.QUERY
   P.menu = '<table width="100%"><tr>\n'
   for _,v in ipairs(P._menu) do
     P.menu = P.menu .. 
      ' <th><a href="' .. v.link .. '">' ..  v.menu ..'</a></th>\n'
   end
   P.menu = P.menu .. '</tr></table>\n\n'

   P.style = [[
<style type='text/css'>
 @media screen {
   body {background-color: #def}
   table, td, th {border-color: #446}
   th {background-color: #cde; font-size: 130%;}
 }
 @media print {
   body {background-color: white}
   table, td, th {border-color: black}
   th {background-color: #ccc}
 }
 body {font-family: sans-serif}
 table {
   empty-cells: show; border-collapse: collapse;
   border-spacing:0; border-style: solid; border-width: 1px
 }
 td {border-style: solid ; border-width: 1px; vertical-align:top;}
 td.l {text-align:left}
 td.r {text-align:right}
 td.c {text-align:center}
 th {border-style: solid ; border-width: 1px}
</style>
]]

   return P
end
